import com.apple.eawt.AboutHandler;
import com.apple.eawt.AppEvent.AboutEvent;
import com.apple.eawt.AppEvent.QuitEvent;
import com.apple.eawt.QuitHandler;
import com.apple.eawt.QuitResponse;

import de.yourwebs.sudoku.AboutDialog;
import de.yourwebs.sudoku.SudokuGUI;

/**
 * Sudoku.java 22.10.2010
 * Copyright 2010 - 2013 yourwebs.de. All rights reserved
 * @author J&ouml;rg Czeschla
 * 
 *         This file is a part of Sudoku. Sudoku is free software; you can
 *         redistribute it and/or modify it under the terms of the GNU General
 *         Public License as published by the Free Software Foundation; either
 *         version 2 of the License, or (at your option) any later version.
 * 
 *         Sudoku is distributed in the hope that it will be useful, but WITHOUT
 *         ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *         FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 *         for more details.
 * 
 *         You should have received a copy of the GNU General Public License
 *         along with Spiele; if not, write to the Free Software Foundation,
 *         Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

public class Sudoku {
	public static void main(String[] args) {
		System.out.println("Starting "
				+ de.yourwebs.sudoku.Config.APP_NAME.value + " "
				+ de.yourwebs.sudoku.Config.APP_VERSION.value + ", build: "
				+ de.yourwebs.sudoku.Config.BUILD.value);
		System.out.println("OS: " + System.getProperty("os.name"));
		System.out.println("OS-VERSION: " + System.getProperty("os.version"));
		System.out.println("WORKINGDIR.: " + System.getProperty("user.dir"));

		System.getProperties().put("apple.laf.useScreenMenuBar", "true");
		new SudokuGUI();
		// Strategie-Pattern zum handeln der MacOSX-Leiste
		String os = System.getProperty("os.name");
		if (os.contains("Mac")) {
			new MacImpl();
		}
	}
}

class MacImpl implements ClassSelector, AboutHandler, QuitHandler {

	public MacImpl() {
		handleOS();
	}

	@Override
    public void handleOS() {
		try {
			final com.apple.eawt.Application application = com.apple.eawt.Application
					.getApplication();
			application.setAboutHandler(this);
			application.setQuitHandler(this);
		} catch (Throwable e) {
			System.err.println("setupMacOSXApplicationListener failed: "
					+ e.getMessage());
		}
	}

	@Override
    public void handleAbout(AboutEvent arg0) {
		new AboutDialog();
	}

	@Override
    public void handleQuitRequestWith(QuitEvent arg0, QuitResponse arg1) {
		System.exit(0);
	}
}

interface ClassSelector {
	public void handleOS();
}
