/**
 * @PrintablePanel.java 07.12.2010 build: 07.12.2010 Copyright 2010 yourwebs.de.
 *                      All rights reserved
 * @author J&ouml;rg Czeschla
 *
 *         This file is a part of Sudoku Sudoku is free software; you can
 *         redistribute it and/or modify it under the terms of the GNU General
 *         Public License as published by the Free Software Foundation; either
 *         version 2 of the License, or (at your option) any later version.
 * 
 *         Sudoku is distributed in the hope that it will be useful, but WITHOUT
 *         ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *         FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 *         for more details.
 * 
 *         You should have received a copy of the GNU General Public License
 *         along with Sudoku; if not, write to the Free Software Foundation,
 *         Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */
package de.yourwebs.sudoku;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.LayoutManager;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;

import javax.swing.JPanel;
import javax.swing.RepaintManager;

/**
 * A printable <code>JPanel</code> used as the main panel of the game.
 * 
 */
public class PrintablePanel extends JPanel implements Printable {

    public PrintablePanel(LayoutManager layout) {
        super(layout);
    }

    @Override
    public int print(Graphics g, PageFormat pageFormat, int pageIndex)
            throws PrinterException {
        if (pageIndex > 0) {
            return (NO_SUCH_PAGE);
        }
        Graphics2D g2d = (Graphics2D) g;
        int x = (int) pageFormat.getImageableX() + 1;
        int y = (int) pageFormat.getImageableY() + 1;
        g2d.translate(x, y);
        RepaintManager currentManager = RepaintManager.currentManager(this);
        currentManager.setDoubleBufferingEnabled(false);
        // scale it a little bit to fit on the sheet
        g2d.scale(0.94, 0.94);
        this.paint(g2d);
        currentManager.setDoubleBufferingEnabled(true);
        return (PAGE_EXISTS);
    }
}
